/*
** Copyright 1989, 1992 by Lionel Fournigault
**
** Permission to use, copy, and distribute for non-commercial purposes,
** is hereby granted without fee, providing that the above copyright
** notice appear in all copies and that both the copyright notice and this
** permission notice appear in supporting documentation.
** The software may be modified for your own purposes, but modified versions
** may not be distributed.
** This software is provided "as is" without any expressed or implied warranty.
**
**
*/

#ifndef  _UNDO_H_
#define  _UNDO_H_

#include "proto_decl.h"

#define U_DEL	0
#define U_ADD	1

#define U_INSERT	2
#define U_REP	3
#define U_GREP	4
#define U_STD	5

typedef struct ud_i {
	char c;		/* Si un seul caractere */
	char *buf;		/* Si plusieurs caracteres */
	int size;		/* Taille de buf */
	int one_char;	/* True or False*/
	int current_line;	/* Ligne courante avant l'operation */
	int pos;		/* Position a partir de la marge avant l'operation */
	int nb_lines;	/* Nombre de lignes stokees */
	int op;		/* Ajouter ou effacer 1 ou plusieurs caracteres */
	int type;		/* Insert file, replace strings etc... */
	char *str_old;	/* Pour le replace */
	char *str_new;	/* Idem */
	struct ud_i *next;	/* Pour le chainage */
	struct ud_i *prev;	/* Idem */
	
} Undo;

#endif /* _UNDO_H_ */
